Lua_RecruitIntroduceWindow = class("Lua_RecruitIntroduceWindow", Lua_Window);

function Lua_RecruitIntroduceWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = -570;

	self.windowName = "Lua_RecruitIntroduceWindow";
	self.skinName = "RecruitIntroduceWindow_skin";
end

function Lua_RecruitIntroduceWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	self:addLuaEvent("OPEN_RECRUIT_REWARDLIST", self, self.onOpenRewardHeroList);
end

function Lua_RecruitIntroduceWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardObj:SetActive(false);
	self.rewardTxt:setLangValue(140347);
	
	--规则说明
	self.ruleDragContainer = Lua_DragContainer.new(self.content, 487, 820, Lua_AxisDefine.Vertical);
   	self.ruleDragContainer:setLocation(4, 16, 0);
   	self.ruleDragContainer.tweenId = DataCenter.recruitUtil.recruitRuleTweenId;
   	self.ruleDragContainer:setSiblingIndex(1);
   	
   	--英雄奖励预览
   	self.rewardHeroList = Lua_DragList.new(self.rewardObj, 487, 487, Lua_AxisDefine.Vertical);
	self.rewardHeroList:setLocation(0, -25, 0);
   	self.rewardHeroList:setListCell(Lua_RewardHeroItem, 99, 130, 5);

    self.rewardMaskBg:addClickFuntion(self, self.onCloseRewardListClick);

   	self:updateContentData();
end

function Lua_RecruitIntroduceWindow:dispose()
	if self.rewardHeroList ~= nil then
		self.rewardHeroList:dispose();
		self.rewardHeroList = nil;
	end
	if self.ruleDragContainer ~= nil then
		self.ruleDragContainer:dispose();
		self.ruleDragContainer = nil;
	end
	self:superCall("dispose");
end

function Lua_RecruitIntroduceWindow:updateContentData()
	for k, v in ipairs(DataCenter.recruitUtil.getRecruitRuleDic) do
		self.ruleDragContainer:addSubContainer(Lua_RecruitIntroduceItem, v, false, 0);
	end
	self.ruleDragContainer:updateChildPos();
	self.ruleDragContainer.canDrag = not self.ruleDragContainer.isTheEnd;
end

function Lua_RecruitIntroduceWindow:onCloseRewardListClick()
	self.rewardObj:SetActive(false);
end

function Lua_RecruitIntroduceWindow:onOpenRewardHeroList(data)
	if data ~= nil then
		local heroList = data[1].hero_list;
		local arr = Array();
		local openState;
		for i = 1, #heroList do
			openState = DataCenter.heroUtil:getNewHeroFuncOpenState(heroList[i][1], Lua_NewHeroFuncOpen.advance_recruit);
			if openState then
				arr:add(heroList[i]);
			end
		end
		self.rewardHeroList:setArrayData(arr);
		self.rewardHeroList:moveToIndex(1, true, false);
		self.rewardObj:SetActive(true);
	end
end

























----------------------------------------------------------------------

Lua_RecruitIntroduceItem = class("Lua_RecruitIntroduceItem", Lua_DragContainerItem);
function Lua_RecruitIntroduceItem:ctor(p)
	self:superCall("ctor", p, "RecruitIntroduceItem_skin");
end

function Lua_RecruitIntroduceItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardBtn:addClickFuntion(self, self.onRewardBtnClick);
end

function Lua_RecruitIntroduceItem:dispose()
	if self.ruleTxt ~= nil then
		self.ruleTxt:dispose();
		self.ruleTxt = nil;
	end
	if self.itemArr ~= nil then
		for i = 1, #self.itemArr do
			self.itemArr[i]:dispose();
		end
		self.itemArr = nil;
	end
	self:superCall("dispose");
end

function Lua_RecruitIntroduceItem:setData(data)
	if data == nil then
		return;
	end
	self.data = data;

	if self.itemArr ~= nil then
		for i = 1, #self.itemArr do
			self.itemArr[i]:setEnable(false);
		end
	end

	local ruleInfo = data[1];
	self.hasRewardBtn = ruleInfo.reward_btn ~= nil and ruleInfo.reward_btn == 1;
	self.rewardBtn:setEnable(self.hasRewardBtn);
	
	if ruleInfo.rule_type == 1 then
		self.tipTxt:setLangValue(140343);
	elseif ruleInfo.rule_type == 2 then
		self.tipTxt:setLangValue(140344);
	elseif ruleInfo.rule_type == 3 then
		self.tipTxt:setLangValue(140345);
	else
		self.tipTxt:setLangValue(140346);
	end

	-- -- ruleInfo.rule_type为1（掉落概率）时标题隐藏
	-- self.tipSp:setEnable(ruleInfo.rule_type ~= 1);
	-- self.tipTxt:setEnable(ruleInfo.rule_type ~= 1);
	-- self.distance = ruleInfo.rule_type ~= 1 and Lua_RecruitUtil.tipHeight + Lua_RecruitUtil.tipDistance or 0;--图标高度、为图标与文本的间隔
	
	local tipHeight = 46;
	local tipDistance = 12;
	self.distance = tipHeight + tipDistance;
	self.count = data:getSize();
	
	if not self.hasRewardBtn then
		if self.ruleTxt == nil then
			self.ruleTxt = UICreate.createLabel(self.content, "", 0, 0, 487, 0, 20);
			self.ruleTxt.alignmentValue = 0;
			self.ruleTxt.verticalOverflowValue = 1;
			-- self.ruleTxt.fontSize = 20;
			self.ruleTxt.colorStr = Lua_ColorDefine.transColorStr("796353");
			self.ruleTxt.fontName = Lua_MyUISettings.defaultFontName;
			self.ruleTxt.lineSpacing = 1.3;
			self.ruleTxt.anchorValue = 1;
		end
		self.ruleTxt.text = ruleInfo.rule;
		self.ruleTxt:resetSize();
		self.ruleTxt:setLocation(0, -self.distance - self.ruleTxt.height/2); 
	else
		if self.itemArr == nil then
			self.itemArr = {};
		end

		local subItem;
		for i = 1, self.count do
			subItem = self.itemArr[i];
			if subItem == nil then
				subItem = Lua_RecruitIntroduceSubItem.new(self.content);
				self.itemArr[i] = subItem;
			end
			subItem:setData(data[i]);
			subItem:setLocation(0, -self.distance - 30 * (i - 0.5));
		end
	end

end

function Lua_RecruitIntroduceItem:onRewardBtnClick()
	Lua_MsgUtil.callFunc("OPEN_RECRUIT_REWARDLIST", self.data);
end

function Lua_RecruitIntroduceItem:getHeight()
	if not self.hasRewardBtn then
		return self.ruleTxt.height + self.distance + 20; -- 20为间隔值
	else
		return self.distance + self.count * self.itemArr[1]:getHeight() + 20; -- 20为间隔值
	end

end

function Lua_RecruitIntroduceItem:getWidth()
	return 487;
end





















---------------------------------------------------------------------

Lua_RecruitIntroduceSubItem = class("Lua_RecruitIntroduceSubItem", Lua_DisplayObject);

function Lua_RecruitIntroduceSubItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_RecruitIntroduceSubItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemNameTxt = UICreate.createLabel(self.content, "", -114, 0, 258, 30, 20);
	self.itemNameTxt.alignmentValue = 3;
	-- self.itemNameTxt.fontSize = 20;
	self.itemNameTxt.colorStr = Lua_ColorDefine.transColorStr("796353");
	self.itemNameTxt.fontName = Lua_MyUISettings.defaultFontName;
	self.itemNameTxt.lineSpacing = 1.3;
	self.itemNameTxt.anchorValue = 1;

	self.probabilityTxt = UICreate.createLabel(self.content, "", 172, 0, 140, 30, 20);
	self.probabilityTxt.alignmentValue = 3;
	-- self.probabilityTxt.fontSize = 20;
	self.probabilityTxt.colorStr = Lua_ColorDefine.transColorStr("796353");
	self.probabilityTxt.fontName = Lua_MyUISettings.defaultFontName;
	-- self.probabilityTxt.lineSpacing = 1.3;
	self.probabilityTxt.anchorValue = 1;

	self:setRectAnchor(1);
end

function Lua_RecruitIntroduceSubItem:dispose()
	if self.itemNameTxt ~= nil then
		self.itemNameTxt:dispose();
		self.itemNameTxt = nil;
	end
	if self.probabilityTxt ~= nil then
		self.probabilityTxt:dispose();
		self.probabilityTxt = nil;
	end
	self:superCall("dispose");
end

function Lua_RecruitIntroduceSubItem:setData(data)
	if data == nil then
		return;
	end

	self.itemNameTxt.text = data.item;
	self.probabilityTxt.text = data.probability;

end

function Lua_RecruitIntroduceSubItem:getHeight()
	return 30;
end




























------------------------------------------------------------------

Lua_RewardHeroItem = class("Lua_RewardHeroItem", Lua_ListCell);
function Lua_RewardHeroItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_RewardHeroItem:buildShowItem()
	self:superCall("buildShowItem");
	
	--英雄Item
	self.heroItem = Lua_ItemIcon.new(self.content);	
	self.heroItem:setLocation(0, 16);
	self.heroItem:setScale(0.8, 0.8, 0.8);

	--英雄背景及名称
	-- self.heroNameBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_tab_01", 0, -48, 100, 32);
	self.heroProbabilityTxt = UICreate.createLabel(self.content, "", 0, -48, 100, 32, 22);
	-- self.heroProbabilityTxt.colorStr = Lua_ColorDefine.transColorStr("76645c");
	self.heroProbabilityTxt.fontName = Lua_MyUISettings.huakangFontName;
	self.heroProbabilityTxt.alignmentValue = 4;
end

function Lua_RewardHeroItem:dispose()
	if self.heroItem ~= nil then
		self.heroItem:dispose();
		self.heroItem = nil;
	end
	if self.heroProbabilityTxt ~= nil then
		self.heroProbabilityTxt:dispose();
		self.heroProbabilityTxt = nil;
	end
	self:superCall("dispose");
end

function Lua_RewardHeroItem:setData(data)
	self.heroId = data[1];
	local tvo = Lua_ToolVo.createToolVo(data[1]);
	self.heroItem:setData(tvo);
	self.heroItem:showText(2, nil);
	
	self.heroProbabilityTxt.text = data[2];
end

function Lua_RewardHeroItem:onPressClick()
	if self.heroId ~= nil then
		local heroVo = Lua_HeroVo.new(self.heroId);
		Lua_WindowUtil.openWin("Lua_HeroExplainTipsWindow", Lua_WinParam.ACTION_OPEN, heroVo);
	end
end
