-- 扭蛋机
Lua_GashaponPanel = class("Lua_GashaponPanel", Lua_DisplayObject);
function Lua_GashaponPanel:ctor(p)
	self:superCall("ctor", p, "GashaponPanel_skin");
end

function Lua_GashaponPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.minX = -185;
	self.maxX = 185;
	self.minY = -5;
	self.maxY = 250;
	self.playShowTime = DataCenter.gashaponUtil.showRewardTime;
	self.playMaxTime = DataCenter.gashaponUtil.showRewardMaxTime;
	self.drawMaskType = self.playMaxTime * 10000 + 2;
	self.gashaponItemsArr = Array();

	self.progressBar.typeValue = 3;
	self.progressBar.fillMethodValue = 1;
	self.progressBar.fillOrigin = 0;
	self.progressBar:addMask();
	self.progressBar:setMaxValue(1000);
	self.progressEff = UICreate.createUIEffect(self.progressBar.mainContent, "/effects/uiEffects/ui_energy_wave", "ui_energy_wave", 0, 0);

	self.skipAniBox.selected = false;
	self.tipsTxt:setLangValue(765011);

	local list = DataCenter.gashaponUtil.moneyList;
	local item;
	self.moneyList = Array();
	for i = 1, #list do
		item = Lua_MoneyItem.new(self.content);
		item:setRectAnchor(1);
		item:setLocation(249 - (i - 1) * 190, -26, 0);
		item:setCanClick(true);
		item:setMoney(list[i]);
		self.moneyList:add(item);
	end

	self.upHeroPoint = Lua_RedPointIcon.new(self.uitweenObj_1, Lua_RedPointList.Recruit_Gashapon_UpHeroTips);
	self.upHeroPoint:setLocation(245, 390, 0);

	self.moreDrawPoint = Lua_RedPointIcon.new(self.uitweenObj_1, Lua_RedPointList.Recruit_Gashapon_MoreDraw);
	self.moreDrawPoint:setLocation(280, -348, 0);

	-- self.ruleBtn.clickScale = false;
	self.ruleBtn:addClickFuntion(self, self.onRuleBtnClick);
	self.upHeroImg:addClickFuntion(self, self.onChangeBtnClick);
	self.changeBtn:addClickFuntion(self, self.onChangeBtnClick);
	self.oneBtn:addClickFuntion(self, self.onOneDrawClick);
	self.moreBtn:addClickFuntion(self, self.onMoreDrawClick);
	self.skipAniBox:addBoxChange(self, self.onSkipAniBoxClick);

	self:addLuaEvent("UPDATE_GASHAPON_INFO", self, self.updateGashaponInfo);
	self:addLuaEvent("UPDATE_GASHAPON_DRAWTIMES_STATE", self, self.setUpdateGashaponDrawTimesState);
	self:addLuaEvent("UPDATE_GASHAPON_COST_INFO", self, self.setDrawInfo);
	self:addLuaEvent("ON_PLAY_GASHAPON_TWEEN", self, self.onPlayGashaponTween);
	self:addLuaEvent("ON_GASHAPON_AGAIN_DRAWONE", self, self.onOneDrawClick);
	self:addLuaEvent("ON_GASHAPON_AGAIN_DRAWMORE", self, self.onMoreDrawClick);
	self:addLuaEvent("ON_GASHAPON_SHOW_MOVEEFF", self, self.onShowMoveEff);
	-- Lua_ProxyManager.getProxy("Lua_GashaponProxy"):sGashaponInfo();

	DataCenter.gashaponData.isFirstOpen = true; -- 策划要求打开一次界面后不再显示红点
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Recruit_Gashapon_MoreDraw, false);

	self:showEffect(1);
	self:updateGashaponInfo();
	self:setUpdateGashaponDrawTimesState();
	self:showGashaponDrawTimesInfo();
end

function Lua_GashaponPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
end

function Lua_GashaponPanel:updateGashaponInfo()
	local gashaponData = DataCenter.gashaponData;
	local gashaponUtil = DataCenter.gashaponUtil;
	local url = "/images/gashapon/xui_ndj_juese_0.png";
	if gashaponData.selectUpHeroInfo then
		url = gashaponData.selectUpHeroInfo.up_hero_img;

		if self.curUpheroVo == nil then
			self.curUpheroVo = Lua_ToolVo.createToolVo(gashaponData.selectUpHeroInfo.reward[1]);
		else
			self.curUpheroVo:setData(gashaponData.selectUpHeroInfo.reward[1]);
		end
		self.upHeroNameTxt.text = self.curUpheroVo.name;
	end
	self.upHeroImg:setUrl(url);
	self.tipsTxt:setEnable(gashaponData.selectUpHeroInfo == nil);
	self.upHeroNameTxt:setEnable(gashaponData.selectUpHeroInfo ~= nil);

	local color = gashaponData.diamondTimes <= 0 and "FD5E42" or "77F294";
	self.canDrawTimesTxt.text = LanUtil.formateStr(765001, color, gashaponData.diamondTimes, gashaponUtil.diamondMaxTimes);
	self.skipAniBox.selected = gashaponData.flag == 1;

	self:setShowGashaponInfo();
	self:setDrawInfo();
	self:showGashaponDrawTimesInfo();
end

function Lua_GashaponPanel:setUpdateGashaponDrawTimesState()
	self.isRefresh = true;
end

function Lua_GashaponPanel:showGashaponDrawTimesInfo()
	if not self.isRefresh then
		return;
	end
	self.isRefresh = false;

	local gashaponData = DataCenter.gashaponData;
	local gashaponUtil = DataCenter.gashaponUtil;
	local totalTimes = gashaponUtil.guaranteeList[1][2];
	if gashaponData.selectUpHeroInfo then
		local camp = getConfig("item", gashaponData.selectUpHeroInfo.reward[1], "camp");
		totalTimes = gashaponUtil.guaranteeList[camp][2];
	end
	self:setEffInfo(gashaponData.curDrawedTimes / totalTimes);
	self.drawedTimesTxt.text = gashaponData.curDrawedTimes;
	self.oneDesTxt.text = LanUtil.formateStr(765000, 1);
	self.moreDesTxt.text = LanUtil.formateStr(765000, gashaponUtil.drawMoreTimes);
end

function Lua_GashaponPanel:setEffInfo(value)
	self.progressBar:setMaxValue(1000);
	self.progressBar:setValue(value * 1000);

	local radius = self.progressBar.height / 2;
	local posY = -40 + value * 80;
	self.progressEff:setLocation(0, posY, 0);

	local rate = value >= 0.5 and value - 0.5 or 0.5 - value;
	local showWidth = Mathf.Sqrt(radius * radius - (rate * radius * rate * radius * 4));
	local scale = showWidth / radius;
	self.progressEff:setScale(scale, scale);

	value = value >= 0.5 and 1 - value or value;
	self.progressEff:setEnable(value >= 0.02);
end

function Lua_GashaponPanel:setShowGashaponInfo()
	local upInfo = DataCenter.gashaponData.selectUpHeroInfo;
	local isSet = false;
	if upInfo == nil then
		isSet = true;
	else
		if self.upId ~= upInfo.id then
			isSet = true;
		end
		self.upId = upInfo.id;
	end

	if isSet then
		local item;
		local posIdx = DataCenter.gashaponUtil.posIdx;
		local arr = DataCenter.gashaponUtil.showRewardArr;
		local showLen = arr:getSize();
		showLen = upInfo ~= nil and showLen + 1 or showLen;
		for i = 1, showLen do
			item = self.gashaponItemsArr[i];
			if item == nil then
				item = Lua_GashaponShowRewardItem.new(self.uitweenObj_1);
				item.contentName = "Lua_GashaponShowRewardItem_" .. i;
				self.gashaponItemsArr:add(item);
			end

			info = arr[i];
			if upInfo then
				if i == posIdx then
					info = nil;
				else
					if i > posIdx then
						info = arr[i - 1];
					end
				end
			end
			item:setData(info);
		end
		self:setShowPos();
	end
end

-- 回到初始位置
function Lua_GashaponPanel:setShowPos()
	local posList = DataCenter.gashaponUtil.noSelectPosList;
	if DataCenter.gashaponData.selectUpHeroInfo then
		posList = DataCenter.gashaponUtil.selectPosList;
	end
	for i = 1, self.gashaponItemsArr:getSize() do
		self.gashaponItemsArr[i]:setLocation(posList[i][1], posList[i][2]);
	end
end

function Lua_GashaponPanel:setDrawInfo()
	self.oneDrawType, self.oneInfo = DataCenter.gashaponData:getOneDrawInfo();
	local tvo = Lua_ToolVo.createToolVo(self.oneInfo[1], self.oneInfo[2]);
	local str = spliceIconStr(tvo.iconAtlas, tvo.iconSprite, tvo.iconWidth * 0.8, tvo.iconHeight * 0.8);
	-- local color = self.oneDrawType == 2 and "FD5E42" or "FFFFFF";
	self.oneCostTxt.text = LanUtil.formateStr(765002, str, color, self.oneInfo[2]);

	self.moreDrawType, self.moreInfo = DataCenter.gashaponData:getMoreDrawInfo();
	tvo = Lua_ToolVo.createToolVo(self.moreInfo[1], self.moreInfo[2]);
	str = spliceIconStr(tvo.iconAtlas, tvo.iconSprite, tvo.iconWidth * 0.8, tvo.iconHeight * 0.8);
	-- color = self.moreDrawType == 2 and "FD5E42" or "FFFFFF";
	self.moreCostTxt.text = LanUtil.formateStr(765002, str, color, self.moreInfo[2]);
end

function Lua_GashaponPanel:showEffect(showType)
	local effectName = showType == 1 and "ui_ndj_caideng_1" or "ui_ndj_caideng_2";
	if self.uiEffect == nil then
		self.uiEffect = UICreate.createUIEffect(self.uitweenObj_1, nil, nil, 0, 0);
	end
	self.uiEffect:setUrl("/effects/uiEffects/" .. effectName, effectName);
	self.uiEffect:setEnable(false);
	self.uiEffect:setEnable(true);
end

function Lua_GashaponPanel:onPlayGashaponTween(list)
	self.showRewardList = list;
	if self.skipAniBox.selected then
		self:onShowRewardFun();
	end
end

function Lua_GashaponPanel:onShowRewardFun()
	self:removeMask();
	if self.drawedIcon then
		self.drawedIcon.alpha = 1;
		self.drawedIcon:setEnable(false);
	end
	if self.drawedEffect ~= nil then
		self.drawedEffect:dispose();
		self.drawedEffect = nil;
	end

	if self.showRewardList then
		local tvo;
		local arr = Array();
		for i = 1, #self.showRewardList do
			tvo = DataCenter.packData:getRewardVo(self.showRewardList[i].item);
			arr:add(tvo);
		end
		Lua_WindowUtil.openWin("Lua_GashaponShowRewardWindow", Lua_WinParam.ACTION_OPEN, arr);
	end
	self.showRewardList = nil;
end

function Lua_GashaponPanel:onRuleBtnClick()
	Lua_WindowUtil.openWin("Lua_GashaponRuleWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_GashaponPanel:onChangeBtnClick()
	Lua_WindowUtil.openWin("Lua_GashaponSelectUpHeroWindow", Lua_WinParam.ACTION_OPEN);
end

-- 单抽
function Lua_GashaponPanel:onOneDrawClick()
	self:onDrawFun(1);
end

-- 多抽
function Lua_GashaponPanel:onMoreDrawClick()
	self:onDrawFun(2);
end

function Lua_GashaponPanel:onDrawFun(param)
	if DataCenter.gashaponData.upId == 0 then
		OperateAlert.showLangValue(765003);
		return;
	end

	self.drawTimes = param == 1 and 1 or DataCenter.gashaponUtil.drawMoreTimes;
	if not DataCenter.heroData:isBagEnough(self.drawTimes) then
		OperateAlert.showLangValue(765012);
		return;
	end

	self.drawType = param == 1 and self.oneDrawType or self.moreDrawType;
	local itemId = param == 1 and self.oneInfo[1] or self.moreInfo[1];
	local itemCost = param == 1 and self.oneInfo[2] or self.moreInfo[2];
	local hasCount = DataCenter.packData:getItemCountById(itemId);
	local drawCond;
	if self.drawType == 0 then -- 钻石
		drawCond = itemCost > hasCount;
	elseif self.drawType == 2 then -- 道具
		drawCond = true;
	end
	if drawCond then
		DataCenter.packUtil:openPathWindow(itemId);
		return;
	end

	if self.drawType == 0 then
		local tvo = Lua_ToolVo.createToolVo(itemId);
		local str = spliceIconStr(tvo.iconAtlas, tvo.iconSprite, tvo.iconWidth * 0.8, tvo.iconHeight * 0.8);
		local tipsData = {
			owner = self,
			des = LanUtil.formateStr(765013, str, itemCost, hasCount, self.drawTimes),
			btnType = 1,
			sureFun = self.onSureDrawFun
		};
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
	else
		self:onSureDrawFun();
	end
end

function Lua_GashaponPanel:onSureDrawFun()
	Lua_ProxyManager.getProxy("Lua_GashaponProxy"):sDrawGashaponReward(self.drawType, self.drawTimes);
	if not self.skipAniBox.selected then
		self:startShowGashaponAni(); -- 播放动画
		DataCenter.chatData:setDelayBroadcast(DataCenter.gashaponUtil.broadcastId);
	end
end

function Lua_GashaponPanel:onShowMoveEff()
	if self.moveEff == nil then
		self.moveEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_ndj_daoju03", "ui_ndj_daoju03", 0, 0);
	end
	self.moveEff:setLocation(0, 120 - self.adaptHeight / 2, 0);
	self.moveEff:setEnable(false);
	self.moveEff:setEnable(true);
	TweenUtil.getInstance():addTweenTargetPos(self.moveEff.mainContent, 1, 0, 305, 585 + self.adaptHeight / 2, 0, self, self.stopMoveEff);
end

function Lua_GashaponPanel:stopMoveEff()
	TweenUtil.getInstance():stop(self.moveEff.mainContent);
	self.moveEff:setEnable(false);
	if self.lightEff == nil then
		self.lightEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_ndj_daoju04", "ui_ndj_daoju04", 305, 585 + self.adaptHeight / 2);
	end
	self.lightEff:setEnable(false);
	self.lightEff:setEnable(true);
	Lua_CommonUtil.delayCall(0.5, self, self.delaySetEnable); -- 切换小卖部页签时不显示
	self:setUpdateGashaponDrawTimesState();
	self:showGashaponDrawTimesInfo();
end

function Lua_GashaponPanel:delaySetEnable()
	if self.lightEff ~= nil then
		self.lightEff:setEnable(false);
	end
end

function Lua_GashaponPanel:onSkipAniBoxClick(state)
	Lua_ProxyManager.getProxy("Lua_GashaponProxy"):sChangeBoxFlag(state and 1 or 0);
end

function Lua_GashaponPanel:dispose()
	self:clearShowGashaponAniTimer();
	if self.moneyList ~= nil then
		self.moneyList:dispose();
		self.moneyList:clear();
		self.moneyList = nil;
	end
	if self.upHeroPoint ~= nil then
		self.upHeroPoint:dispose();
		self.upHeroPoint = nil;
	end
	if self.moreDrawPoint ~= nil then
		self.moreDrawPoint:dispose();
		self.moreDrawPoint = nil;
	end
	if self.gashaponItemsArr ~= nil then
		self.gashaponItemsArr:dispose();
		self.gashaponItemsArr = nil;
	end
	if self.uiEffect ~= nil then
		self.uiEffect:dispose();
		self.uiEffect = nil;
	end
	if self.drawedEffect ~= nil then
		self.drawedEffect:dispose();
		self.drawedEffect = nil;
	end
	if self.drawedIcon ~= nil then
		self.drawedIcon:dispose();
		self.drawedIcon = nil;
	end
	if self.moveEff ~= nil then
		self.moveEff:dispose();
		self.moveEff = nil;
	end
	if self.lightEff ~= nil then
		self.lightEff:dispose();
		self.lightEff = nil;
	end
	self.curUpheroVo = nil;
	Lua_CommonUtil.removeTimer(self, self.onShowRewardFun);
	self:superCall("dispose");
end










---------------------------------------- 扭蛋机动画 ----------------------------------------
function Lua_GashaponPanel:startShowGashaponAni()
	self:addMask();
	self.startShowGashaponAniTime = getTime();
	if not self.bAddGashaponAniTimer then
		self:showGashaponItems(true);
		self.bAddGashaponAniTimer = true;
		Lua_CommonUtil.addTimer("gashaponAniTimer", 0.2, self, self.onShowGashaponAni, nil, nil, true);
	end
end

function Lua_GashaponPanel:onShowGashaponAni()
	local t = getTime() - self.startShowGashaponAniTime;
	if t > self.playMaxTime then -- 服务端还未返回直接停
		self:clearShowGashaponAniTimer();
		self:removeMask();
	elseif t >= self.playShowTime and self.showRewardList ~= nil then -- 有结果
		self:showDrawedGashapon();
		self:clearShowGashaponAniTimer();
	else
		self:showGashaponItems(true);
	end
end

function Lua_GashaponPanel:clearShowGashaponAniTimer()
	if self.bAddGashaponAniTimer then
		self.bAddGashaponAniTimer = false;
		Lua_CommonUtil.removeTimer(self, self.onShowGashaponAni, true);
	end
end

function Lua_GashaponPanel:addMask()
	DataCenter.gashaponData.isDrawTween = true; -- 开始播放动画
	self:showEffect(2);
	Lua_MsgUtil.callFunc("RECRUIT_OPEN_MASK", self.drawMaskType);
end

function Lua_GashaponPanel:removeMask()
	DataCenter.gashaponData.isDrawTween = false; -- 动画播放完毕
	self:setShowPos();
	self:showEffect(1);
	Lua_MsgUtil.callFunc("RECRUIT_OPEN_MASK", 0);
end

-- 掉下扭蛋
function Lua_GashaponPanel:showDrawedGashapon()
	local info = DataCenter.gashaponUtil:getSingleHeroInfo(self.showRewardList[1].gashapon_id);
	if info == nil then
		info = DataCenter.gashaponUtil:getSingleUpHeroInfo(self.showRewardList[1].gashapon_id);
	end

	if self.drawedIcon == nil then
		self.drawedIcon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 102, 102);
		self.drawedIcon.anchorValue = 7;
	end
	self.drawedIcon.alpha = 0.1;
	self.drawedIcon:setAltas(info.atlas, info.sprite);
	self.drawedIcon:setEnable(true);
	self.drawedIcon:setLocation(0, 496, 0);

	TweenUtil.getInstance():addTweenTargetAlpha(self.drawedIcon.mainContent, 0.1, 0, 1, true);
	TweenUtil.getInstance():addTweenTargetPos(self.drawedIcon.mainContent, 0.3, 0, 0, 463, 0, self, self.onDrawedEff);
end

function Lua_GashaponPanel:onDrawedEff()
	DataCenter.chatData:playNextBroadcast(DataCenter.gashaponUtil.broadcastId);
	self.drawedEffect = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_ndj_shanguang", "ui_ndj_shanguang", 0, 0 - self.adaptHeight / 2);
	Lua_CommonUtil.delayCall(0.5, self, self.onShowRewardFun);
end

function Lua_GashaponPanel:showGashaponItems(bStacking)
	local t = getTime();
	for i = 1, self.gashaponItemsArr:getSize() do
		self.gashaponItemsArr[i].checkTime = t;

		local tx = Mathf.Random(self.minX, self.maxX); -- 重新随机
		local ty = Mathf.Random(self.minY, self.maxY); -- 重新随机
		self:checkGashaponPos(t, tx, ty, self.gashaponItemsArr[i], 1, bStacking);
	end
end

function Lua_GashaponPanel:checkGashaponPos(checkTime, tx, ty, item, step, bStacking)
	local bAdapterPos = true; -- 是否在方框内（位置是否适配）
	if tx < self.minX or tx > self.maxX or ty < self.minY or ty > self.maxY then
		bAdapterPos = false;
	end

	local leftMinDisX = nil;
	local rightMinDisX = nil;
	local leftStackItem = nil;
	local rightStackItem = nil;
	if bAdapterPos then
		for i = 1, self.gashaponItemsArr:getSize() do
			local compareItem = self.gashaponItemsArr[i];
			if compareItem ~= item and compareItem.checkTime == checkTime then
				local comparePosX = compareItem.recordPosX;
				local comparePosY = compareItem.recordPosY;
				local dis = Mathf.Sqrt((tx - comparePosX) ^ 2 + (ty - comparePosY) ^ 2); -- 两个item间距离
				if dis < (item.radius + compareItem.radius) then -- 位置重叠
					bAdapterPos = false;
					break;
				elseif bStacking then -- 找到x轴向最近的
					dis = tx - comparePosX;
					if dis > 0 then -- 右
						if rightMinDisX == nil or dis < rightMinDisX then
							rightMinDisX = dis;
							rightStackItem = compareItem;
						end
					elseif dis < 0 then -- 左
						if leftMinDisX == nil or dis > leftMinDisX then
							leftMinDisX = dis;
							leftStackItem = compareItem;
						end
					else -- 顶部
						leftMinDisX = 0;
						rightMinDisX = 0;
						leftStackItem = compareItem;
						rightStackItem = compareItem;
					end
				end
			end
		end
	end

	if bAdapterPos then -- 位置合适
		if bStacking and leftStackItem ~= nil and rightStackItem ~= nil then -- 堆叠，y轴往下探寻
			local leftStackPosX = leftStackItem.recordPosX;
			local leftStackPosY = leftStackItem.recordPosY;
			local rightStackPosX = rightStackItem.recordPosX;
			local rightStackPosY = rightStackItem.recordPosY;
			local dis = rightStackPosX - leftStackPosX;
			if dis >= 4 * item.radius then -- 容得下，设置Y值
				tx = leftStackPosX + 2 * item.radius;
				ty = self.minY;
			else
				local a = leftStackItem.radius + item.radius;
				local b = rightStackItem.radius + item.radius;
				local c = Mathf.Sqrt((leftStackPosX - rightStackPosX) ^ 2 + (leftStackPosY - rightStackPosY) ^ 2);
				local x, y = self:calTriangleThirdPoint(leftStackPosX, leftStackPosY, rightStackPosX, rightStackPosY,
					tx, ty, a, b, c);
				if x ~= nil and y ~= nil then
					tx = x;
					ty = y;
					if ty < self.minY + item.gashaponIcon.height / 2 then
						ty = self.minY;
					end
				end
			end
		end

		item.checkTime = checkTime;
		item:setNewPos(tx, ty);
		TweenUtil.getInstance():addTweenTargetPos(item.mainContent, 0.1, 0, tx, ty, 0);
	else
		step = step + 1;
		tx = Mathf.Random(self.minX, self.maxX); -- 重新随机
		ty = Mathf.Random(self.minY, self.maxY); -- 重新随机
		self:checkGashaponPos(checkTime, tx, ty, item, step);
	end
end

-- 已知三角形的两点坐标，和三个边长，求第三点的坐标
function Lua_GashaponPanel:calTriangleThirdPoint(ax, ay, bx, by, cx, cy, a, b, c)
	local cosA = (b*b + c*c - a*a) / (2*b*c);
	if cosA > 1.0 or cosA < -1.0 then
		print("calTriangleThirdPoint nil");
		return;
	end

	local angleA = Mathf.Acos(cosA);
	local sinA = Mathf.Sin(angleA);
	if (ax - cx) * (by - cy) - (bx - cx) * (ay - cy) > 0 then
		sinA = -Mathf.Sin(angleA);
	end

	local dx = bx - ax;
	local dy = by - ay; 
	local tx =  cosA * dx + sinA * dy;
	local ty = -sinA * dx + cosA * dy;
	tx, ty = self:getNormalize(tx, ty);
	-- tx, ty = Vector2.Normalize(tx, ty);
	tx = ax + tx * b;
	ty = ay + ty * b;
	return tx, ty;
end

-- 将向量的长度变为1，让距离保持一致，以免在对角线上移动时比水平或垂直移动快
function Lua_GashaponPanel:getNormalize(x, y)
	local magnitude = Mathf.Sqrt(x * x + y * y)
	if magnitude > 1e-05 then
		x = x / magnitude
		y = y / magnitude
	else
		x = 0
		y = 0
	end
	return x, y
end










Lua_GashaponShowRewardItem = class("Lua_GashaponShowRewardItem", Lua_DisplayObject);
function Lua_GashaponShowRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_GashaponShowRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.recordPosX = self.posX;
	self.recordPosY = self.posY;
	self.gashaponIcon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
	self.gashaponIcon:addClickFuntion(self, self.onShowItemInfo);
end

function Lua_GashaponShowRewardItem:setData(data)
	local itemId, atlas, sprite, effType;
	if data then
		local info = DataCenter.gashaponUtil:getSingleHeroInfo(data);
		itemId = info.reward[1];
		atlas = info.atlas;
		sprite = info.sprite;
		effType = info.is_effect;
	else
		local upInfo = DataCenter.gashaponData.selectUpHeroInfo;
		itemId = upInfo.reward[1];
		atlas = upInfo.atlas;
		sprite = upInfo.sprite;
		effType = upInfo.is_effect;
	end
	self.gashaponIcon:setAltas(atlas, sprite);
	self.gashaponIcon:resetSize();

	if self.tvo == nil then
		self.tvo = Lua_ToolVo.createToolVo(itemId);
	else
		self.tvo:setData(itemId);
	end
	self:showEffect(effType);
end

function Lua_GashaponShowRewardItem:showEffect(effType)
	if effType then
		local effectName = effType == 1 and "ui_ndj_daoju01_s" or "ui_ndj_daoju01";
		local posX = effType == 1 and 195 or 0;
		local posY = effType == 1 and 0 or 0;
		local url = "/effects/uiEffects/"..effectName;
		if self.uiEffect == nil then
			self.uiEffect = UICreate.createUIEffect(self.content, url, effectName, 0, 0);
		else
			self.uiEffect:setUrl(url, effectName);
		end
		self.uiEffect:setLocation(posX, posY, 0);
		self.uiEffect:setEnable(true);
	else
		if self.uiEffect then
			self.uiEffect:setEnable(false);
		end
	end
end

function Lua_GashaponShowRewardItem:onShowItemInfo()
	if self.tvo then
		DataCenter.packUtil:showItemInfo(self.tvo);
	end
end

function Lua_GashaponShowRewardItem:setNewPos(posX, posY)
	self.recordPosX = posX;
	self.recordPosY = posY;
end

function Lua_GashaponShowRewardItem.Get:radius()
	-- self.gashaponIcon.height / 2;
	return 40;
end

function Lua_GashaponShowRewardItem:dispose()
	if self.gashaponIcon ~= nil then
		self.gashaponIcon:dispose()
		self.gashaponIcon = nil;
	end
	if self.uiEffect ~= nil then
		self.uiEffect:dispose()
		self.uiEffect = nil;
	end
	self.tvo = nil;
	self:superCall("dispose");
end