Lua_GashaponRuleWindow = class("Lua_GashaponRuleWindow", Lua_Window);
function Lua_GashaponRuleWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GashaponRuleWindow";
	self.skinName = "GashaponRuleWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = -400;
end

function Lua_GashaponRuleWindow:buildShowItem()
	self:superCall("buildShowItem");

	local upInfo = DataCenter.gashaponData.selectUpHeroInfo;
	local totalTimes = DataCenter.gashaponUtil.guaranteeList[1][2];
	if upInfo then
		local camp = getConfig("item", upInfo.reward[1], "camp");
		totalTimes = DataCenter.gashaponUtil.guaranteeList[camp][2];
	end
	self.ruleTxt.text = LanUtil.formateStr(765004, totalTimes);
	self.ruleTxt:resetSize();

	local posY = self.ruleTxt.posY - self.ruleTxt.height - 32;
	LuaUtil.setObjPos(self.infoObj, 0, posY, 0);

	local rectH = 390 + 189 - self.ruleTxt.height - 28;
	local rewardList = DataCenter.gashaponUtil.gashponRuleInfoDic;
	self.rewardList = Lua_DragList.new(self.content, 500, rectH, Lua_AxisDefine.Vertical);
	self.rewardList.canDrag = #rewardList * 30 > rectH;
	self.rewardList:setListCell(Lua_GashaponRuleItem, 98, 114, 5);
	self.rewardList:setCellSpacing(0, 5);
	self.rewardList:setLocation(0, -97 + (189 - self.ruleTxt.height - 28) / 2);
	self.rewardList:setArrayData(rewardList);
end

function Lua_GashaponRuleWindow:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end










Lua_GashaponRuleItem = class("Lua_GashaponRuleItem", Lua_ListCell);
function Lua_GashaponRuleItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_GashaponRuleItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(0, 10.5, 0);
	self.itemIcon:setScale(0.75, 0.75, 0.75);

	self.percent = UICreate.createLabel(self.content, "", 0, -48, 140, 30, 18);
	self.percent.alignmentValue = 4;
	self.percent.horizontalOverflowValue = 1;
	self.percent.colorStr = Lua_ColorDefine.transColorStr("DEE0E9");
end

function Lua_GashaponRuleItem:setData(data)
	if data == nil then
		return;
	end

	local upInfo = DataCenter.gashaponData.selectUpHeroInfo;
	local itemId = data.item_info[1];
	local itemCount = data.item_info[2];
	local probability = data.probability_1;
	if upInfo then
		if itemCount == 0 then
			itemId = upInfo.reward[1];
			itemCount = 1;
		end
		local camp = getConfig("item", upInfo.reward[1], "camp");
		if camp == Lua_HeroUtil.LIGHT_TYPE then
			probability = data.probability_2;
		else
			probability = data.probability_1;
		end
	end
	if self.tvo == nil then
		self.tvo = Lua_ToolVo.createToolVo(itemId, itemCount);
	else
		self.tvo:setData(itemId, itemCount);
	end
	self.itemIcon:setData(self.tvo);
	self.percent.text = probability;
end

function Lua_GashaponRuleItem:onPressClick()
	if self.tvo then
		DataCenter.packUtil:showItemInfo(self.tvo);
	end
end

function Lua_GashaponRuleItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.percent ~= nil then
		self.percent:dispose();
		self.percent = nil;
	end
	self:superCall("dispose");
end