Lua_GashaponSelectUpHeroWindow = class("Lua_GashaponSelectUpHeroWindow", Lua_Window);
function Lua_GashaponSelectUpHeroWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GashaponSelectUpHeroWindow";
	self.skinName = "GashaponSelectUpHeroWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GashaponSelectUpHeroWindow:buildShowItem()
	self:superCall("buildShowItem");

	local arr = DataCenter.heroUtil.siftAllInfo;
	self.infoBg_2:SetDimensions(arr:getSize() * 94, 60);

	self.upHeroList = Lua_DragList.new(self.content, 635, 238, Lua_AxisDefine.Vertical);
	self.upHeroList:setListCell(Lua_GashaponSelectUpHeroItem, 127, 112, 5);
	self.upHeroList.canLongPress = true;
	self.upHeroList.longPressLimit = 0.4;
	self.upHeroList:setCellSpacing(0, 21);
	self.upHeroList:setLocation(0, 18, 0);

	self.campSiftPanel = Lua_CampSiftPanel.new(self.content);
	self.campSiftPanel:setLocation(-37, -154, 0);
	self.campSiftPanel:setSiftItem(73, "595959", 28);
	self.campSiftPanel:setArrayData(arr);
	self.campSiftPanel:setCallBack(self, self.onCampSelected);
	self.campSiftPanel:setSelected(Lua_HeroUtil.All_TYPE, true);

	self.cancelBtn:addClickFuntion(self, self.hide);
	self.sureBtn:addClickFuntion(self, self.onSureBtnClick);
	self:addLuaEvent("ON_SELECT_GASHAPON_UPHERO_ITEMCLICK", self, self.recordSelectInfo);
end

function Lua_GashaponSelectUpHeroWindow:onCampSelected(campType)
	self:setTipsShow(campType);
	self:selectUpHeroByCampType(campType);
end

function Lua_GashaponSelectUpHeroWindow:setTipsShow(campType)
	local upInfo = self.recordInfo or DataCenter.gashaponData.selectUpHeroInfo;
	if upInfo then
		campType = getConfig("item", upInfo.reward[1], "camp");
	else
		campType = 1;
	end
	local totalTimes = DataCenter.gashaponUtil.guaranteeList[campType][2];
	self.tipsTxt.text = LanUtil.formateStr(765014, totalTimes);
end

function Lua_GashaponSelectUpHeroWindow:selectUpHeroByCampType(campType)
	local arr = DataCenter.gashaponUtil:getAllUpHeroInfo();
	local info;
	if campType ~= Lua_HeroUtil.All_TYPE then
		local heroVo;
		local showInfoArr = Array();
		for i = 1, arr:getSize() do
			info = DataCenter.gashaponUtil:getSingleUpHeroInfo(arr[i]);
			heroVo = Lua_ToolVo.createToolVo(info.reward[1]);
			if heroVo.campType == campType then
				showInfoArr:add(arr[i]);
			end
		end
		arr = showInfoArr;
	end

	local idx;
	local upInfo = self.recordInfo or DataCenter.gashaponData.selectUpHeroInfo;
	for i = 1, arr:getSize() do
		if upInfo and arr[i] == upInfo.id then
			idx = i;
			break;
		end
	end
	self.upHeroList.curSelectedIdx = nil;
	self.upHeroList:setArrayData(arr);
	self.upHeroList:moveToIndex(idx or 1, true);

	if upInfo and idx then -- 没选择默认不选中
		self.upHeroList:setSelected(idx);
	end
	self:setNoneInfo(arr:getSize() <= 0);
end

function Lua_GashaponSelectUpHeroWindow:setNoneInfo(state)
	if state then
		if self.noneText == nil then
			self.noneText = UICreate.createLabel(self.content, LanUtil.getValue(765005), 0, 18, 0, 30, 40);
			self.noneText.alignmentValue = 4;
			self.noneText.horizontalOverflowValue = 1;
			self.noneText.fontName = Lua_MyUISettings.huakangFontName;
		end
		self.noneText:setEnable(true);
	else
		if self.noneText ~= nil then
			self.noneText:setEnable(false);
		end
	end
end

function Lua_GashaponSelectUpHeroWindow:recordSelectInfo(recordInfo)
	self.recordInfo = recordInfo;

	local camp = getConfig("item", recordInfo.reward[1], "camp");
	self:setTipsShow(camp);
end

function Lua_GashaponSelectUpHeroWindow:onSureBtnClick(go)
	local upInfo = self.recordInfo or DataCenter.gashaponData.selectUpHeroInfo;
	if upInfo == nil then
		OperateAlert.showLangValue(765003);
	else
		Lua_MsgUtil.callFunc("UPDATE_GASHAPON_DRAWTIMES_STATE");
		Lua_ProxyManager.getProxy("Lua_GashaponProxy"):sChangeGashaponUpHero(upInfo.id);
		self:hide();
	end
end

function Lua_GashaponSelectUpHeroWindow:dispose()
	if self.upHeroList ~= nil then
		self.upHeroList:dispose();
		self.upHeroList = nil;
	end
	if self.campSiftPanel ~= nil then
		self.campSiftPanel:dispose();
		self.campSiftPanel = nil;
	end
	self:superCall("dispose");
end










Lua_GashaponSelectUpHeroItem = class("Lua_GashaponSelectUpHeroItem", Lua_ListCell);
function Lua_GashaponSelectUpHeroItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_GashaponSelectUpHeroItem:buildShowItem()
	self:superCall("buildShowItem");

	self.upHeroIcon = Lua_ItemIcon.new(self.content);
	self.upHeroIcon:setScale(0.9, 0.9, 0.9);
end

function Lua_GashaponSelectUpHeroItem:setData(data)
	self._data = DataCenter.gashaponUtil:getSingleUpHeroInfo(data);
	if data == nil or self._data == nil then
		return;
	end

	local isGray = false;
	if self._data.tower_id then
		local towerVo = DataCenter.climbTowerData:getTowerVoById(Lua_ClimbTowerUtil.LIGHT_ID);
		local config = DataCenter.climbTowerUtil:getTowerConfig(self._data.tower_id);
		if towerVo.cur_storey < config.storey then
			isGray = true;
		end
	end
	if self.tvo == nil then
		self.tvo = Lua_ToolVo.createToolVo(self._data.reward[1]);
	else
		self.tvo:setData(self._data.reward[1]);
	end
	self.upHeroIcon:setData(self.tvo);
	self.upHeroIcon:setMask(isGray);
end

function Lua_GashaponSelectUpHeroItem:onPressClick()
	if self._data.tower_id then
		local towerVo = DataCenter.climbTowerData:getTowerVoById(Lua_ClimbTowerUtil.LIGHT_ID);
		local config = DataCenter.climbTowerUtil:getTowerConfig(self._data.tower_id);
		if towerVo.cur_storey >= config.storey then
			Lua_MsgUtil.callFunc("ON_SELECT_GASHAPON_UPHERO_ITEMCLICK", self._data);
		else
			OperateAlert.show(LanUtil.formateStr(765015, config.storey));
			return;
		end
	else
		Lua_MsgUtil.callFunc("ON_SELECT_GASHAPON_UPHERO_ITEMCLICK", self._data);
	end
	return true;
end

function Lua_GashaponSelectUpHeroItem:onLongPressClick()
	-- self.upHeroIcon:onItemClick();
	local heroVo = Lua_ToolVo.createToolVo(self.tvo.hero_id);
	Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroAttr(heroVo.id, heroVo.star, 1);
end

function Lua_GashaponSelectUpHeroItem:onSelectionChange(bSelect)
	self:superCall("onSelectionChange", bSelect);
	self.upHeroIcon:setDrawMask(bSelect);
end

function Lua_GashaponSelectUpHeroItem:dispose()
	if self.upHeroIcon ~= nil then
		self.upHeroIcon:dispose();
		self.upHeroIcon = nil;
	end
	self._data = nil;
	self.tvo = nil;
	self:superCall("dispose");
end